/*   $OSSEC, getloglocation.h, v0.2, 2005/04/25, Daniel B. Cid$   */

/* Copyright (C) 2005 Daniel B. Cid <dcid@ossec.net>
 * All right reserved.
 *
 * This program is a free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation
 */


#ifndef __GETLL_H

#define __GETLL_H

#include "eventinfo.h"
#include "os_zlib/os_zlib.h"

/*
 * Start the log location (need to be called before getlog)
 *
 */
void OS_InitLog();

/* Compress a log using gzip.
 *
 */
int OS_CompressLog(int yesterday, char *prev_month, int prev_year);


/*
 * Get the log file based on the date/logtype/
 *
 * @param lf        Event structure
 *
 * @retval 0        success
 *         -1       error 
 */
int OS_GetLogLocation(Eventinfo *lf);

FILE *_eflog;
FILE *_aflog;
FILE *_fflog;

#endif /* GETLL_H */
